<?

include_once "templates/templates.inc.php";

// Load the necessary templates to speed up
// generation of archives..
function load_templates() {
global $row, $blog_row, $archive_templ, $arcentry_templ;
	$archive_templ=implode("", file("templates/archive.html"));
	$arcentry_templ=implode("", file("templates/archiveentry.html"));
	get_entry_xml("blog.php");
	$blog_row=$row;
}



function parse_archive() {
global $archive_templ;
	$output="<mode=literal><mode=nobr>";
	$this_archive=parse_step1($archive_templ);
	$output.=parse_step2($this_archive);
	return $output;
}


function write_archive($filename, $silent=1) {
global $output, $pretty, $version;

		$output=trim($output);
		$output.="\n<!-- Created with Pivot $version -->\n";

		$fp=fopen("../$filename","w");
		fwrite($fp, $output);
		fclose($fp);
		debug("wrote: <b>$filename</b>: ".strlen($output));
		if ($silent==1) { 
			printf("<tr><td>%s</td><td>%s</td><td>%s</td></tr>\n", timetaken(), $pretty[$filename], $filename);
		}

}

function parse_entry() {
global $arcentry_templ, $row, $global_user, $global_pref,$diffdate_lastformat, $entry;

	$diffdate_thisformat=format_date($row["date"],$global_pref['diffdate_format']);
	if ($diffdate_lastformat!=$diffdate_thisformat) {
		$diffdate_lastformat=$diffdate_thisformat;
	} else {
		$diffdate_thisformat="";
	}

	if (isset($row['comments'])) {
		$commcount=count($row['comments']);
	} else {
		$commcount=0;
	}
	$global_pref['commentsarr']=explode("|",$global_pref['comments']);
	$global_pref['comments_numbersarr']=explode("|",$global_pref['comments_numbers']);
		
	if ($commcount<1) { 
		$commcount=$global_pref['commentsarr'][0];
		$commcount=str_replace("%num%", $global_pref['comments_numbersarr'][0], $commcount);
	} else if ($commcount==1) { 
		$commcount=$global_pref['commentsarr'][1]; 
		$commcount=str_replace("%num%", $global_pref['comments_numbersarr'][1], $commcount);
	} else {
		$commcount=$global_pref['commentsarr'][2]; 
		$commcount=str_replace("%num%", $global_pref['comments_numbersarr'][count($row['comments'])], $commcount);
	}

	
	//commnames does not work in archive..
	
	// make a nice array for the names of people that gave comments
	if (isset($row['comments'])) {
		foreach ($row['comments'] as $thiscomm) {
			$commnames[]=$thiscomm['name'];
		}
		
		$commnames=implode(", ", array_unique($commnames) );
	} else {
		$commnames="";
	}


	$file=str_replace("%1", rem_code_padding($row["code"]), $global_pref['file_format']);

	if (strlen($row['body'])>10) {
		$readmore="<a href=\"%link%#body\">".$global_pref['readmore']."</a>";
	} else {
		$readmore="";
	}

	if (!isset($global_user[$row["user"]])) {
		$row['user']='nobody';
	}



	$this_entry= $arcentry_templ;

	//$commnames=implode(", ",$entry['cnames']);

	$this_entry= str_replace("%title%", $row["title"], $this_entry);
	$this_entry= str_replace("%subtitle%", $row["subtitle"], $this_entry);
	$this_entry= str_replace("%code%", rem_code_padding($row["code"]), $this_entry);
	$this_entry= str_replace("%body%", $row["body"], $this_entry);
	$this_entry= str_replace("%introduction%", "<mode=br><mode=escaped>".$row["introduction"]."<mode=nobr><mode=literal>", $this_entry);
	$this_entry= str_replace("%xml-introduction%", xml2html($row["introduction"]), $this_entry);
	$this_entry= str_replace("%user%", $row["user"], $this_entry);
	$this_entry= str_replace("%diffdate%", $diffdate_thisformat, $this_entry);
	$this_entry= str_replace("%more%", $readmore, $this_entry);
	$this_entry= str_replace("%date%", format_date($row["date"],$global_pref['entrydate_format']), $this_entry);
	$this_entry= str_replace("%nick%", $global_user[$row["user"]]['nickname'], $this_entry);
	$this_entry= str_replace("%email%", $global_user[$row["user"]]['email'], $this_entry);
	$this_entry= str_replace("%commlink%", $file."#comm", $this_entry);
	$this_entry= str_replace("%link%", $file, $this_entry);
	$this_entry= str_replace("%commcount%", $commcount, $this_entry);
	$this_entry= str_replace("%commnames%", $commnames, $this_entry);


	return $this_entry;


}


function arcnum2date($number,$year, $filename) {
global $global_pref;

	$format=$global_pref['archive_linkfile'];

	if ($global_pref['archive_unit']=="week") {
		$length=$global_pref['archive_amount']-1;
		list($st_ye, $st_mo, $st_da)=split("-",date  ("Y-m-d", mktime (0,0,0,1,((int)$number*7)-6,$year)));
		list($en_ye, $en_mo, $en_da)=split("-",date("Y-m-d", mktime (0,0,0,1,((int)$number+$length)*7,$year)));

	}

	if ($global_pref['archive_unit']=="month") {
		$length=$global_pref['archive_amount'];
		list($st_ye, $st_mo, $st_da)=split("-",date ("Y-m-d", mktime (0,0,0,(int)$number,1,$year)));
		list($en_ye, $en_mo, $en_da)=split("-",date ("Y-m-d", mktime (0,0,0,(int)$number+$length,0,$year)));

	}

	// Don't try to make archives by month, and formatting them using weeknumbers 
	// That's silly, and it doesn't work..

	$format=str_replace("%st_day%", $st_da, $format);
	$format=str_replace("%st_weeknum%", $number, $format);
	$format=str_replace("%st_month%", $st_mo, $format);
	$format=str_replace("%st_monthname%", $global_pref['months'][((int)$st_mo)-1], $format);
	$format=str_replace("%st_monname%", $global_pref['mon'][((int)$st_mo)-1], $format);
	$format=str_replace("%st_year%", $st_ye, $format);
	$format=str_replace("%st_ye%", $st_ye, $format);

	$format=str_replace("%en_day%", $en_da, $format);
	$format=str_replace("%en_weeknum%", ($number+$length), $format);
	$format=str_replace("%en_month%", $en_mo, $format);
	$format=str_replace("%en_monname%", $global_pref['mon'][((int)$en_mo)-1], $format);
	$format=str_replace("%en_year%", $en_ye, $format);
	$format=str_replace("%en_ye%", $en_ye, $format);
	$format=str_replace("%url%", $filename, $format);

	return $format;
//	debug($format);
}


// then create an array, containing the archive volumes and which
// files should go into that archive..
function create_archive_index($until="") {
	global $archive, $db, $global_pref, $current_date;

	// do not allow '$until' if archive_list is too old..
	if (file_exists("../archive_list.html")) {
		$time= filemtime("../archive_list.html");
		$daysold = (date("yz", $time) - date("yz"));
		if( (($global_pref['archive_unit']=="week")&&($daysold>3)) ||
			(($global_pref['archive_unit']=="month")&&($daysold>14))) {
			$until="";
			debug ("reset 'until'");
		}
	} else {
		$until="";
		debug ("reset 'until' (cause dont exist)");
	}


	$archive=Array();

	$db = new db_xml('standard',TRUE);
	
	$res=$db->setpointer("last");


	do {

		if ($db->entry['date'] <= $current_date) { 
			$date=format_date($db->entry['date'],"%day%-%month%");
			if ($global_pref['archive_unit']=="week") {
				$per=format_date($db->entry['date'],"%weeknum%");
			}
			if ($global_pref['archive_unit']=="month") {
				$per=format_date($db->entry['date'],"%month%");
			}

			$year=format_date($db->entry['date'],"%year%");
			$archive_num=floor($per/$global_pref['archive_amount']) * $global_pref['archive_amount'];
			$archive_type= ($global_pref['archive_unit']=="week") ? "w" : "m";
			$archive_name=sprintf("%04d-%s%02d", $year, $archive_type, $archive_num);

			if ( ($until!="") && ($archive_name < $until) ) {
				break;
			}
			$archive[$archive_name][]=$db->entry['code'];
			//debug("arcname: $archive_name");
		}
		$res=$db->setpointer("prev");
	} while ($res);

	ksort($archive);

	if ($until=="") {
		make_archive_list();
	}

}



function make_archive_list() {
global $global_pref, $archive, $pretty, $archive_numbered, $current_date;

	debug("ar-list in");

	if ( (isset($global_pref['archive_order'])) && ($global_pref['archive_order']!="chronological") ) {
		$archive= array_reverse($archive);
	}

	$format=$global_pref['archive_linkfile'];

	$fp=fopen("../archive_list.html", "w");
	foreach ($archive as $key => $value) {
		$name=$key;
		
		list($year,$number)= split("-", $name);
		$number=preg_replace("/[wm]/mi","",$number);
		$file=str_replace("%1",$name,$global_pref['archive_format']);
		$output=arcnum2date($number, $year, $file);

		fwrite($fp,$output);
	
		$archive_numbered[]=$name;
		$pretty[$file]=$output;
	}

	fclose($fp);

	if ( (isset($global_pref['archive_order'])) && ($global_pref['archive_order']!="chronological") ) {
		$archive= array_reverse($archive);
	}


	debug("ar-list out");

}

function generate_archives() {
global $archive, $archive_count, $output, $global_pref, $weblog, $db, $version, $arc_key, $arc_value, $arc_count, $amount, $offset;

	echo "<h1>Generating Archives..</h1>";
	echo "<div class='extrapadding2'>";

	$arc_count=0;

	// Then we walk the $archive array, and output some files.
	foreach($archive as $arc_key => $arc_value){

		if ($arc_count>=$offset) {
		
			flush();
			echo timetaken()."$arc_key => ". count($arc_value)." entries<br>\n";
			flush();

			$file=str_replace("%1",$arc_key,$global_pref['archive_format']);


			$template=load_template($weblog['archive-template']); 
	
			$template=str_replace("[[weblog", "[[archive", $template);

			$output="<mode=literal><mode=nobr>".$template;
			$output=parse_step4($output);
			$output=parse_step1($output);
			$output=parse_step4($output);
			$output=parse_step2($output);
			$output=parse_step4($output);
			$output=parse_step3($output);
			$output=parse_step4($output);
		
		
			$output.="\n<!-- Created with Pivot $version -->\n";

			$fp=fopen('../'.$file,"w"); 
			fwrite($fp, $output);
			fclose ($fp);
		} else {
			debug("skip: niet $arc_count >= $offset");
		}
	
		$arc_count++;
		
		if ($arc_count>=($amount+$offset)) {break; }

	}

	$timetaken=timetaken('int');
	printf("<br>Generated %s archive files in %s seconds. Thats %s files per second<br>\n\n", ($arc_count-$offset), $timetaken, number_format(($arc_count/$timetaken), 2));

}


function generate_last_archive() {
global $archive, $archive_count, $output, $global_pref, $weblog, $db, $version, $arc_key, $arc_value, $arc_count, $amount, $offset;

	end($archive);
	$arc_key=key($archive);
	//debug("key: $arc_key");
	generate_single_archive($arc_key);
}


function generate_single_archive($arc_mykey) {
global $archive, $archive_count, $output, $global_pref, $weblog, $db, $version, $arc_key, $arc_value, $arc_count, $amount, $offset;

	$arc_key=$arc_mykey;

	$arc_value=$archive[$arc_key];

	// make the archive file..
	$file=str_replace("%1",$arc_key,$global_pref['archive_format']);

	$template=load_template($weblog['archive-template']); 

	$template=str_replace("[[weblog", "[[archive", $template);

	$output="<mode=literal><mode=nobr>".$template;
	$output=parse_step4($output);
	$output=parse_step1($output);
	$output=parse_step4($output);
	$output=parse_step2($output);
	$output=parse_step4($output);
	$output=parse_step3($output);
	$output=parse_step4($output);
	
	$output.="\n<!-- Created with Pivot $version -->\n";

	$fp=fopen('../'.$file,"w"); 
	fwrite($fp, $output);
	fclose ($fp);

}



function generate_first_archive() {
global $archive, $archive_count, $output, $count, $global_pref;

	// Then we walk the $archive array, and output some files.
	foreach($archive as $arc_key => $arc_value){

		$output=parse_archive();
		$archive_entries="";
		$archive_count++;
		// for each entry in the $archive array, we parse all the xml files and
		// insert them in the archive.
		for ($i=0;$i<count($arc_value);$i++) {

			$filename=$arc_value[$i];
			get_entry_xml($filename);
			$archive_entries.=parse_entry();
		}
		$count++;

		// insert the archive_entries into the template
		$output=str_replace("%archive%", $archive_entries, $output);

		// Then, we do parse_step3, to get rid of <mode=br> etc.
		$output=parse_step3($output);

		// finally. figure out the filename, and write it to disk..
		$arc_filename=str_replace("%1",$arc_key,$global_pref['archive_format']);
		write_archive($arc_filename, 0);

		// ooh, this is evil.. just generate all archives, but quit after the first one.
		// I should be ashamed of myself..
		break;
	}

}



function generate_files() {
	global $global_pref, $index, $row, $entry, $index_count;

	sort_index_by_code();

	// reset the index;
	$index_count=0;

	//reset the 'last date' 
	$diffdate_lastformat="";

	$count=0;

	// reset the counter..
	$starttime= microtime(); 

	// print everything

	for ($i=0;$i<count($index);$i++) {
		get_entry();
		
		if ( ($count % 50)==0) {
			flush();
			echo "\n<br>$count: ";
		}
		echo ".";
		$count++;

		get_entry_xml($entry['file']);
		$filename=generate_page($row['id'], 'generate', '');
	}

	$filename=str_replace("%1", "blog", $global_pref['local_path'].$global_pref['file_format']);
	$indexpage=sprintf("%s%s",$global_pref['local_path'], $global_pref['index']);
	//debug($filename);
	//debug($indexpage);
	copy ($filename, $indexpage);

	$count++;

	$timetaken=timetaken('int');
	printf("\n\n<br><br>Generated %s files in %s seconds. Thats %s files per second", $count, $timetaken, number_format(($count/$timetaken), 2));

}

?>