<?

include_once("snippets.php");
include_once("snippets_standard.php");

// ----------------------------------------------------
// first the general functions we use to generate pages
// ----------------------------------------------------
// Eventually, these will all be changed into one Class.


function generate_page($uid, $generatefor, $outputfileoverride) {
	global $db, $template_cache, $template, $global_pref, $row, $output, $chunks, $version, $HTTP_SERVER_VARS;

	// First we import a template.. if the one specified does not
	// exist, we revert to default.html

	//debug("templ=".$db->entry['template']);
	$template=load_template($db->entry['template']); 
	
	
	$output="<mode=literal><mode=nobr>".$template;
	$output=parse_step4($output);
	$output=parse_step1($output);
	$output=parse_step4($output);
	$output=parse_step2($output);
	$output=parse_step4($output);
	$output=parse_step3($output);
	$output=parse_step4($output);
	

	// Mojo is finished, output file here..
	

	
	// figure out what filename to write to.
	$path=$global_pref['local_path'];
	if ($outputfileoverride == '') {
		$file=$global_pref['file_format'];
	} else {
		$file=$outputfileoverride;
	}
	
	// if we generate for a preview, add a snippet of javascript to 
	// pop the window to the front, if it is not already..
	if ($generatefor=="preview") {
		$output.="<script>\n";
		$output.="self.focus();\n</script>\n";
	}

	$output.="\n<!-- Created with Pivot $version -->\n";

	finish_rss();
		
	if ($generatefor=="live") {
		$base_href="http://".$HTTP_SERVER_VARS['HTTP_HOST'].$global_pref['log_url'];
		$output=preg_replace("/<head>/mi","<head>\n<base href='".$base_href."'>", $output);
		return $output;
	} else {
		$fp=fopen($db->get_outputfile(),"w"); 
		fwrite($fp, $output);
		fclose ($fp);
		return $db->get_outputfile();
	}
	
}

function generate_static($name) {
	global $db, $version, $global_pref;

	//echo "<pre>";
	//print_r($db->globals);
	//echo "</pre>";

	if (isset($db->globals['staticpage-template'])) {
		$template=load_template($db->globals['staticpage-template']); 
	} else {
		$template=load_template($db->globals['frontpage-template']);
	}

	// a dirty trick to make the parser put in the 'static' page, instead of the weblog.
	$template=str_replace("[[weblog:", "[[static:$name:", $template);
	$template=str_replace("[[weblog]]", "[[static:$name]]", $template);
	
	$filename=str_replace("%1",$name,$global_pref['file_format']);

	$output="<mode=literal><mode=nobr>".$template;
	$output=parse_step4($output);
	$output=parse_step1($output);
	$output=parse_step4($output);
	$output=parse_step2($output);
	$output=parse_step4($output);
	$output=parse_step3($output);
	$output=parse_step4($output);
	
	$output.="\n<!-- Created with Pivot $version -->\n";

	$fp=fopen('../'.$filename,"w"); 
	fwrite($fp, $output);
	fclose ($fp);

	return '../'.$filename;

}

// not used anymore..
function generate_page_bycode($code, $generatefor, $outputfileoverride) {
global $db, $table, $table_content, $global_pref, $row, $output, $chunks;

	$table_content=$global_pref['table_content'];
	$result = mysql_query("SELECT * FROM $table_content where code='$code'",$db);

	$row = mysql_fetch_array($result);
	$uid=$row['uid'];

	return generate_page($uid, $generatefor, $outputfileoverride);
} 

// ----------------------------------------------------
// Then the functions in which the actual parsing takes place
// ----------------------------------------------------


// in which we only substitute <cms body>, <cms introduction> and <cms include>..
// we do this so that <cms> codes in these will be translated in step 2
// we also include <mode> tags where appropiate.
function parse_step1($text) {
	$chunks=explode("</cms>", $text); // split the file
	for ($i=0; $i<(sizeof($chunks)-1); $i++) {
		splitchunk($chunks[$i], $plain_html, $tag_name, $tag_attr, $tag_default);
		switch ($tag_name):
			case "introduction":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_introduction($tag_attr, $tag_default)."<mode=nobr><mode=literal>";
				break;
			case "body":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_body($tag_attr, $tag_default)."<mode=nobr><mode=literal>";
				break;
			case "include":
				$chunks[$i]=$plain_html.cms_tag_include($tag_attr, $tag_default);
				break;
		endswitch;

	}
	return implode($chunks, "</cms>"); // glue together

}

// in which we parse all the other tags, including the ones that were 
// inserted in step 1
function parse_step2($text) {
	$chunks=explode("</cms>", $text); // split the file
	//debug_r($chunks);
	for ($i=0; $i<(sizeof($chunks)-1); $i++) {
		splitchunk($chunks[$i], $plain_html, $tag_name, $tag_attr, $tag_default);

		switch ($tag_name):
			case "bonus1":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_bonus($tag_attr, $tag_default, "bonus1")."<mode=nobr><mode=literal>";
				break;
			case "bonus2":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_bonus($tag_attr, $tag_default, "bonus2")."<mode=nobr><mode=literal>";
				break;
			case "bonus3":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_bonus($tag_attr, $tag_default, "bonus3")."<mode=nobr><mode=literal>";
				break;
			case "bonus4":
				$chunks[$i]="$plain_html<mode=br><mode=escaped>".cms_tag_bonus($tag_attr, $tag_default, "bonus4")."<mode=nobr><mode=literal>";
				break;
			case "title":
				$chunks[$i]=$plain_html.cms_tag_title($tag_attr, $tag_default);
				break;
			case "subtitle":
				$chunks[$i]=$plain_html.cms_tag_subtitle($tag_attr, $tag_default);
				break;
			case "code":
				$chunks[$i]=$plain_html.cms_tag_code($tag_attr, $tag_default);
				break;
			case "filename":
				$chunks[$i]=$plain_html.cms_tag_filename($tag_attr, $tag_default);
				break;
			case "user":
				$chunks[$i]=$plain_html.cms_tag_user($tag_attr, $tag_default);
				break;
			case "nick":
				$chunks[$i]=$plain_html.cms_tag_nick($tag_attr, $tag_default);
				break;
			case "email":
				$chunks[$i]=$plain_html.cms_tag_email($tag_attr, $tag_default);
				break;
			case "link":
				$chunks[$i]=$plain_html.cms_tag_link($tag_attr, $tag_default);
				break;
			case "date":
				$chunks[$i]=$plain_html.cms_tag_date($tag_attr, $tag_default);
				break;
			case "media":
				$chunks[$i]=$plain_html.cms_tag_media($tag_attr, $tag_default);
				break;
			case "path":
				$chunks[$i]=$plain_html.cms_tag_path($tag_attr, $tag_default);
				break;
			case "menu":
				$chunks[$i]=$plain_html.cms_tag_menu($tag_attr, $tag_default);
				break;
			case "weblog":
				$chunks[$i]=$plain_html.cms_tag_weblog($tag_attr, $tag_default); //, $row["code"], $row["title"]);
				break;
			case "archive":
				$chunks[$i]=$plain_html.cms_tag_archive($tag_attr, $tag_default); //, $row["code"], $row["title"]);
				break;
			case "comments":
				$chunks[$i]=$plain_html.cms_tag_comments($tag_attr, $tag_default);
				break;
			case "commentslist":
				$chunks[$i]=$plain_html.cms_tag_commentslist($tag_attr, $tag_default);
				break;
			case "parent_title":
				$chunks[$i]=$plain_html.cms_tag_parenttitle($tag_attr, $tag_default);
				break;
			case "parent_parent_title":
				$chunks[$i]=$plain_html.cms_tag_parentparenttitle($tag_attr, $tag_default);
				break;
			case "parent_code":
				$chunks[$i]=$plain_html.cms_tag_parentcode($tag_attr, $tag_default);
				break;
			case "parent_parent_code":
				$chunks[$i]=$plain_html.cms_tag_parentparentcode($tag_attr, $tag_default);
				break;
			case "parent_parent_parent_code":
				$chunks[$i]=$plain_html.cms_tag_parentparentparentcode($tag_attr, $tag_default);
				break;
			case "parent_subtitle":
				$chunks[$i]=$plain_html.cms_tag_parentsubtitle($tag_attr, $tag_default);
				break;
			case "parent_parent_subtitle":
				$chunks[$i]=$plain_html.cms_tag_parentparentsubtitle($tag_attr, $tag_default);
				break;
			case "include":
				$chunks[$i]=$plain_html.cms_tag_include($tag_attr, $tag_default);
				break;
		endswitch;
	}
	return implode($chunks, ""); // glue together

}

// in which we look for <mode=br> en <mode=literal> tags, so we can 
// output the file as supposed..
function parse_step3($text) {

	// mode_br toggles whether we should substitute newlines ( \n ) for <br>'s
	// mode_esc toggles whether text should be quoted literally or if < should be translated
	// to &gt; and  to &euml;, etc..
	$mode_br=0;
	$mode_esc=0;
	$output="";

	// a bit of code to translate &lt;mode=nobr&gt; to <mode=nobr>
	$text=str_replace("&lt;mode","<mode",$text);
	$text=str_replace("br&gt;","br>",$text);
	$text=str_replace("nobr&gt;","nobr>",$text);
	$text=str_replace("escaped&gt;","escaped>",$text);
	$text=str_replace("literal&gt;","literal>",$text);

	$lines=explode("<mode", $text );
	for ($i=0; $i<(sizeof($lines)); $i++) {
		$len=strlen($lines[$i]);
		$sub=substr ($lines[$i], 0, 10);
		// 
		//$pos=strpos($lines[$i],"br>");
		
		// switch mode_br ?
		if (strpos($lines[$i],"br>") == 1) {  
			$mode_br=1; 
			$lines[$i]=substr($lines[$i],4);
		}
		if (strpos($lines[$i],"nobr>") == 1) {  
			$mode_br=0; 
			$lines[$i]=substr($lines[$i],6);
		}

		// switch mode_escaped ?
		if (strpos($lines[$i],"escaped>") == 1) {  
			$lines[$i]=substr($lines[$i],9);
			//$output.="<!-- mode_esc moet aan  -->";
			$mode_esc=1;
		}
		if (strpos($lines[$i],"literal>") == 1) {  
			$lines[$i]=substr($lines[$i],9);
			$mode_esc=0;
		}

		// if mode_esc then translate to html
		if ($mode_esc==1) { 
			$lines[$i]=escape($lines[$i]);  
		}

		// if mode_br is set, include <br> with line-breaks
		if ($mode_br==1) { 
			$lines[$i]=nl2br($lines[$i]); 
		}


		$output.=$lines[$i];
	}
	return $output;
}

function parse_step4 ($text) {

	preg_match_all ("|\[\[(.*)\]\]|U", $text, $match, PREG_PATTERN_ORDER);

	foreach($match[1] as $snippet_code) {
		$snippet_replace= snippet_parse ( $snippet_code );
		//if ($snippet_replace) {
		$text=str_replace("[[".$snippet_code."]]", $snippet_replace, $text);
		//}
	}

	return $text;
}


function snippet_parse($snippet_code) {

	@list($command, $para1, $para2,$para3,$para4,$para5)= explode(":", $snippet_code); 
	
	$insert="";

	if ($command=="/link") { $command="slasha"; }
	if ($command=="internal-link") { $command="internallink"; }

	$command=str_replace("/","slash",$command);

	$function="snippet_".$command;
	if (function_exists($function)) {
		$insert=$function($para1, $para2,$para3,$para4,$para5);
	} else {
		$insert="<!-- snippet '$command' is not defined -->";
		//$insert="(snippet '$command' is not defined)";
		debug ("snippeterror: $command");

	}
	
	return $insert;

}


// ----------------------------------------------------
// Then the functions for the <cms> tags..
// ----------------------------------------------------



// ----------------------------------------------------
// Finally some auxillary functions.
// ----------------------------------------------------

function load_template($basename) {
	global $template_cache;

	$filename="templates/$basename";

	if (isset($template_cache[$basename])) {
		return $template_cache[$basename];
	} else {
		if (!(file_exists($filename))) { 
			$filename="templates/longentry.html";
		}
		if (!(file_exists($filename))) { 
			$filename="templates/blogentry.html";
		}

		$filetext=implode("", file($filename));
	
		$template_cache[$basename]=$filetext;
		
		return $filetext;
	}

}


// this function will split a chunk of text to four more manageable
// variables $plain_html, $tag_name, $tag_attr, $tag_default...
// should only be used when parsing cms templates.
// notice the vars passed by reference!!!
// example:
// splitchunk("<title><cms title color="green, whatever">Hello!</cms></title>",
//		$plain_html, $tag_name, $tag_attr, $tag_default);
//
// will give:
// &$plain_html will be '<title>'
// &$tag_name will be 'title'
// &$tag_attr will be 'color="green, whatever"'
// &$tag_default will be 'Hello!'
function splitchunk($chunk, &$plain_html, &$tag_name, &$tag_attr, &$tag_default) {

//	if ( ereg( "(.*)<cms (.*)", $chunk, $regs ) ){
//		$plain_html=$regs[1];
//		$text=$copy=$regs[2];
	$pos=strpos($chunk,"cms ");
	if (!(is_string ($pos) && !$pos)) {
//    	echo "na ereg: ".timetaken()."<br>\n";
		$plain_html=substr($chunk,0,$pos-1);
		$text=$copy=substr($chunk, $pos+4);
		
		// firstly, let's kick dem escaped quotes.. remember, this example is ok..
		// example <cms whatever attribute="Bob says \"Hi!\"."> 
		// so we need to eliminate escaped qoutes.
		$copy=str_replace('\"', 'xx', $copy);
		
		do {
			if (strpos($copy,'"')>0) {
				$leftpos=strpos($copy, '"');
				//echo $leftpos;
				$copy[$leftpos]="*";
				//echo "leftpos= $copy\n\n\n\n";
				if (strpos($copy,'"')>0) {
					$rightpos=strpos($copy, '"');
					blankout($copy, $leftpos, $rightpos);
					//echo "text= $copy\n\n";
				}
			}
		} while (strpos($copy,'"')>0);
		$copy_delim1=min(strpos($copy, " "), strpos($copy, ">") );
		$copy_delim2=strpos($copy, ">");
		$tag_name=substr($text, 0, $copy_delim1);
		if ($copy_delim2 > $copy_delim1) {
			$tag_attr=substr($text, ($copy_delim1), ($copy_delim2 - $copy_delim1));
		} else {
			$tag_attr="";
		}
		$tag_default=substr($text, $copy_delim2+1, strlen($text));
		if ($tag_name=="") { $tag_name=$tag_attr; $tag_attr=""; }
		
	} else {
	// if there's no <cms whatever> in the passed chunk, just return the whole thing as plain html.. 
	$tag_name="";
	$plain_html=$chunk;
	
	}
}


?>